diff -c ../zip19i/tailor.h ./tailor.h
*** ../zip19i/tailor.h	Tue Nov  3 21:07:55 1992
--- ./tailor.h	Thu Sep  9 22:46:50 1993
***************
*** 1,10 ****
! /* tailor.h -- Not copyrighted 1992 Mark Adler */
  
- /* const's are inconsistently used across ANSI libraries--kill for all
-    header files.  */
- #define const
- 
- 
  /* Define MSDOS for Turbo C and Power C */
  #ifdef __POWERC
  #  define __TURBOC__
--- 1,5 ----
! /* tailor.h -- Not copyrighted 1993 Mark Adler */
  
  /* Define MSDOS for Turbo C and Power C */
  #ifdef __POWERC
  #  define __TURBOC__
***************
*** 20,52 ****
  #endif
  
  /* Use prototypes and ANSI libraries if _STDC__, or Microsoft or Borland C,
!  * or Silicon Graphics, or IBM C Set/2, or GNU gcc under emx.
   */
! #if (defined(__STDC__) || defined(MSDOS) || defined(sgi))
  #  ifndef PROTO
  #    define PROTO
  #  endif /* !PROTO */
  #  define MODERN
! #endif /* MSDOS */
  
! #if (defined(__IBMC__) || defined(__EMX__) || defined(ATARI_ST))
  #  ifndef PROTO
  #    define PROTO
  #  endif /* !PROTO */
  #  define MODERN
! #  ifdef far
! #    undef far
! #    undef near
! #    undef huge
! #  endif
  #endif
  
  #ifdef __IBMC__
  #  define S_IFMT 0xF000
  #endif /* __IBMC__ */
  
! #if (defined(__EMX__) || defined(__WATCOMC__)) && !defined(__32BIT__)
! #  define __32BIT__
  #endif
  
  #if (defined(__OS2__) && !defined(OS2))
--- 15,51 ----
  #endif
  
  /* Use prototypes and ANSI libraries if _STDC__, or Microsoft or Borland C,
!  * or Silicon Graphics, or IBM C Set/2, or Watcom C, or GNU gcc under emx.
   */
! #if defined(__STDC__) || defined(MSDOS) || defined(ATARI_ST) || defined(sgi)
  #  ifndef PROTO
  #    define PROTO
  #  endif /* !PROTO */
  #  define MODERN
! #endif
  
! #if defined(__IBMC__) || defined(__EMX__) || defined(__WATCOMC__)
  #  ifndef PROTO
  #    define PROTO
  #  endif /* !PROTO */
  #  define MODERN
! #endif
! 
! #if defined(__BORLANDC__) || (defined(__alpha) && defined(VMS))
! #  ifndef PROTO
! #    define PROTO
! #  endif /* !PROTO */
! #  define MODERN
  #endif
  
  #ifdef __IBMC__
  #  define S_IFMT 0xF000
  #endif /* __IBMC__ */
  
! #if defined(__EMX__) || defined(__WATCOMC__) || defined(__BORLANDC__)
! #  if (defined(OS2) && !defined(__32BIT__))
! #    define __32BIT__
! #  endif
  #endif
  
  #if (defined(__OS2__) && !defined(OS2))
***************
*** 54,60 ****
  #endif
  
  #ifdef __convexc__
! #	define CONVEX
  #endif /* __convexc__ */
  
  #ifdef __COMPILER_KCC__
--- 53,59 ----
  #endif
  
  #ifdef __convexc__
! #       define CONVEX
  #endif /* __convexc__ */
  
  #ifdef __COMPILER_KCC__
***************
*** 80,85 ****
--- 79,88 ----
  #  define OF(a) ()
  #endif /* ?PROTO */
  
+ /* Avoid using const if compiler does not support it */
+ #ifndef MODERN  /* if this fails, try: ifndef__STDC__ */
+ #  define const
+ #endif
  
  #ifdef MACOS
  #  define DYN_ALLOC
***************
*** 90,111 ****
  #    define DYN_ALLOC
       /* Turbo C 2.0 does not accept static allocations of large arrays */
       void far * fcalloc OF((unsigned items, unsigned size));
  #  else /* !__TURBOC__ */
  #    include <malloc.h>
  #    define farmalloc _fmalloc
  #    define farfree   _ffree
  #    define fcalloc(nitems,itemsize) halloc((long)(nitems),(itemsize))
  #  endif /* ?__TURBOC__ */
  #else /* !MSDOS */
  #  if defined(WIN32)
  #    include <malloc.h>
  #  endif
! #  define huge
! #  define far
! #  define near
  #  define farmalloc malloc
  #  define farfree   free
  #  define fcalloc(items,size) calloc((unsigned)(items), (unsigned)(size))
  #  if (!defined(PROTO) && !defined(TOPS20))
       extern char *calloc(); /* essential for 16 bit systems (AT&T 6300) */
  #  endif
--- 93,124 ----
  #    define DYN_ALLOC
       /* Turbo C 2.0 does not accept static allocations of large arrays */
       void far * fcalloc OF((unsigned items, unsigned size));
+      void fcfree (void *ptr);
  #  else /* !__TURBOC__ */
  #    include <malloc.h>
  #    define farmalloc _fmalloc
  #    define farfree   _ffree
  #    define fcalloc(nitems,itemsize) halloc((long)(nitems),(itemsize))
+ #    define fcfree(ptr) hfree((void huge *)(ptr))
  #  endif /* ?__TURBOC__ */
  #else /* !MSDOS */
  #  if defined(WIN32)
  #    include <malloc.h>
  #  endif
! #  ifdef __WATCOMC__
! #    undef huge
! #    undef far
! #    undef near
! #  endif
! #  ifndef __IBMC__
! #    define huge
! #    define far
! #    define near
! #  endif
  #  define farmalloc malloc
  #  define farfree   free
  #  define fcalloc(items,size) calloc((unsigned)(items), (unsigned)(size))
+ #  define fcfree    free
  #  if (!defined(PROTO) && !defined(TOPS20))
       extern char *calloc(); /* essential for 16 bit systems (AT&T 6300) */
  #  endif
***************
*** 120,126 ****
  #endif
      
  
! /* Define MSVMS if either MSDOS or VMS defined */
  #if defined(MSDOS) || defined(VMS)
  #  define MSVMS
  #endif
--- 133,139 ----
  #endif
      
  
! /* Define MSVMS if MSDOS or VMS defined -- ATARI also does, Amiga could */
  #if defined(MSDOS) || defined(VMS)
  #  define MSVMS
  #endif
***************
*** 128,136 ****
  /* case mapping functions. case_map is used to ignore case in comparisons,
   * to_up is used to force upper case even on Unix (for dosify option).
   */
! #if defined(OS2) || defined(MSDOS) || defined(VMS)
! #  define case_map(c) upper[c]
! #  define to_up(c)    upper[c]
  #else
  #  define case_map(c) (c)
  #  define to_up(c)    ((c) >= 'a' && (c) <= 'z' ? (c)-'a'+'A' : (c))
--- 141,149 ----
  /* case mapping functions. case_map is used to ignore case in comparisons,
   * to_up is used to force upper case even on Unix (for dosify option).
   */
! #if defined(MSDOS) || defined(VMS) || defined(OS2) || defined(WIN32) || defined(AMIGA)
! #  define case_map(c) upper[(c) & 0xff]
! #  define to_up(c)    upper[(c) & 0xff]
  #else
  #  define case_map(c) (c)
  #  define to_up(c)    ((c) >= 'a' && (c) <= 'z' ? (c)-'a'+'A' : (c))
***************
*** 143,149 ****
  #    include <stddef.h>
  #  endif /* !M_XENIX */
  #  include <stdlib.h>
! #  ifdef __386BSD__
  #    include <unistd.h>
  #  endif
     typedef size_t extent;
--- 156,162 ----
  #    include <stddef.h>
  #  endif /* !M_XENIX */
  #  include <stdlib.h>
! #  if defined(SYSV) || defined(__386BSD__)
  #    include <unistd.h>
  #  endif
     typedef size_t extent;
***************
*** 160,165 ****
--- 173,179 ----
  #  include <stat.h>
  #  define unlink delete
  #  define NO_SYMLINK
+ #  define SSTAT vms_stat
  #else /* !VMS */
  #  ifdef MACOS
  #    include <types.h>
***************
*** 176,185 ****
  #      include <ext.h>
  #      include <tos.h>
  #    else
! #      include <sys/types.h>
  #      include <sys/stat.h>
  #    endif
  #  endif
  #endif /* ?VMS */
  
  /* Some systems define S_IFLNK but do not support symbolic links */
--- 190,216 ----
  #      include <ext.h>
  #      include <tos.h>
  #    else
! #      ifdef AMIGA
!          int wild OF((char *));
!          /* default to MEDIUM_MEM, but allow makefile override */
! #        if ( (!defined(BIG_MEM)) && (!defined(SMALL_MEM)))
! #           define MEDIUM_MEM
! #        endif
! #        if defined(LATTICE) || defined(__SASC)
! #        include <sys/types.h>
! #          include <sys/stat.h>
!            extern int isatty(int);   /* SAS has no unistd.h */
! #      endif
! #        ifdef AZTEC_C
! #          include "amiga/z-stat.h"
! #          define RMDIR
! #        endif
! #      else /* !AMIGA */
! #        include <sys/types.h>
  #      include <sys/stat.h>
  #    endif
  #  endif
+ #  endif
  #endif /* ?VMS */
  
  /* Some systems define S_IFLNK but do not support symbolic links */
***************
*** 201,207 ****
  #  define FOPM  "r+","ctx=stm","rfm=fix","mrs=512"
  #  define FOPW  "w","ctx=stm","rfm=fix","mrs=512"
  #else /* !VMS */
! #  ifdef MODERN
  #    define FOPR "rb"
  #    define FOPM "r+b"
  #    ifdef TOPS20 /* TOPS20 MODERN? You kidding? */
--- 232,238 ----
  #  define FOPM  "r+","ctx=stm","rfm=fix","mrs=512"
  #  define FOPW  "w","ctx=stm","rfm=fix","mrs=512"
  #else /* !VMS */
! #  if defined(MODERN)
  #    define FOPR "rb"
  #    define FOPM "r+b"
  #    ifdef TOPS20 /* TOPS20 MODERN? You kidding? */
***************
*** 210,218 ****
--- 241,255 ----
  #      define FOPW "wb"
  #    endif
  #  else /* !MODERN */
+ #    ifdef AMIGA
+ #      define FOPR "rb"
+ #      define FOPM "rb+"
+ #      define FOPW "wb"
+ #    else /* !AMIGA */
  #    define FOPR "r"
  #    define FOPM "r+"
  #    define FOPW "w"
+ #    endif /* ?AMIGA */
  #  endif /* ?MODERN */
  #endif /* VMS */
  
***************
*** 229,238 ****
   * This is not mandatory, just a speed optimization. The compressed
   * output is strictly identical.
   */
! #if defined(MSDOS) || defined(i386) || defined(mc68020) || defined(vax)
! #   define UNALIGNED_OK
  #endif
! 
  
  /* Under MSDOS we may run out of memory when processing a large number
   * of files. Compile with MEDIUM_MEM to reduce the memory requirements or
--- 266,277 ----
   * This is not mandatory, just a speed optimization. The compressed
   * output is strictly identical.
   */
! #if (defined(MSDOS) && !defined(WIN32)) || defined(i386)
! #    define UNALIGNED_OK
  #endif
! #if defined(mc68020) || defined(vax)
! #    define UNALIGNED_OK
! #endif
  
  /* Under MSDOS we may run out of memory when processing a large number
   * of files. Compile with MEDIUM_MEM to reduce the memory requirements or
***************
*** 248,255 ****
  # else
  #  ifdef OS2
  #   ifdef __32BIT__
! #     define CBSZ 0x10000  /* 64k */
! #     define ZBSZ 0x40000  /* 256k */
  #   else
  #     define CBSZ 0xE000
  #     define ZBSZ 0x7F00 /* Some libraries do not allow a buffer size > 32K */
--- 287,294 ----
  # else
  #  ifdef OS2
  #   ifdef __32BIT__
! #     define CBSZ 0x40000
! #     define ZBSZ 0x40000
  #   else
  #     define CBSZ 0xE000
  #     define ZBSZ 0x7F00 /* Some libraries do not allow a buffer size > 32K */
***************
*** 270,275 ****
--- 309,322 ----
  #   define DYN_ALLOC
  #endif
  
+ #ifdef __human68k__
+ #  include <sys/xglob.h>
+ #  define MSVMS
+ #  define SSTAT h68_stat
+   int h68_stat OF((char *, struct stat *));
+ #  define OS_CODE  0x300  /* pretend it's Unix */
+ #endif
+ 
  #ifdef ATARI_ST
  #  define MSDOS  /* what? should be fixed */
  #  define MSVMS
***************
*** 302,309 ****
    int st_findfirst OF((char *, struct ffblk *, int));
    int st_rename    OF((char *, char *));
    int st_rmdir     OF((char *));
! #else
  #  define SSTAT      stat
  #endif
     
  /* end of tailor.h */
--- 349,403 ----
    int st_findfirst OF((char *, struct ffblk *, int));
    int st_rename    OF((char *, char *));
    int st_rmdir     OF((char *));
! #endif  /* ATARI */
! 
! #ifndef SSTAT
  #  define SSTAT      stat
  #endif
+ #ifdef S_IFLNK
+ #  define LSTAT      lstat
+ #else
+ #  define LSTAT      SSTAT
+ #endif
+ 
     
+ /* The following OS codes are defined in pkzip appnote.txt */
+ #ifdef AMIGA
+ #  define OS_CODE  0x100
+ #endif
+ #ifdef VMS
+ #  define OS_CODE  0x200
+ #endif
+ /* unix    3 */
+ /* vms/cms 4 */
+ #ifdef ATARI_ST
+ #  define OS_CODE  0x500
+ #endif
+ #ifdef OS2
+ #  define OS_CODE  0x600
+ #endif
+ #ifdef MACOS
+ #  define OS_CODE  0x700
+ #endif
+ /* z system 8 */
+ /* cp/m     9 */
+ #ifdef TOPS20
+ #  define OS_CODE  0xa00
+ #endif
+ #ifdef WIN32
+ #  define OS_CODE  0xb00
+ #endif
+ /* qdos 12 */
+ 
+ #if defined(MSDOS) && !defined(OS_CODE)
+ #  define OS_CODE  0x000
+ #endif
+ #ifndef OS_CODE
+ #  define OS_CODE  0x300  /* assume Unix */
+ #  ifndef UNIX
+ #    define UNIX
+ #  endif
+ #endif
+ 
+ 
  /* end of tailor.h */
Only in .: tops20
diff -c ../zip19i/trees.c ./trees.c
*** ../zip19i/trees.c	Tue Nov  3 21:07:56 1992
--- ./trees.c	Tue Aug 31 22:08:36 1993
***************
*** 1,11 ****
  /*
  
!  Copyright (C) 1990-1992 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included
!  unmodified, that it is not sold for profit, and that this copyright notice
!  is retained.
  
  */
  
--- 1,10 ----
  /*
  
!  Copyright (C) 1990-1993 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included,
!  that it is not sold for profit, and that this copyright notice is retained.
  
  */
  
***************
*** 463,477 ****
  {
      int v = heap[k];
      int j = k << 1;  /* left son of k */
      while (j <= heap_len) {
          /* Set j to the smallest of the two sons: */
          if (j < heap_len && smaller(tree, heap[j+1], heap[j])) j++;
  
          /* Exit if v is smaller than both sons */
!         if (smaller(tree, v, heap[j])) break;
  
          /* Exchange v with the smallest son */
!         heap[k] = heap[j],  k = j;
  
          /* And continue down the tree, setting j to the left son of k */
          j <<= 1;
--- 462,480 ----
  {
      int v = heap[k];
      int j = k << 1;  /* left son of k */
+     int htemp;       /* required because of bug in SASC compiler */
+ 
      while (j <= heap_len) {
          /* Set j to the smallest of the two sons: */
          if (j < heap_len && smaller(tree, heap[j+1], heap[j])) j++;
  
          /* Exit if v is smaller than both sons */
!         htemp = heap[j];
!         if (smaller(tree, v, htemp)) break;
  
          /* Exchange v with the smallest son */
!         heap[k] = htemp;
!         k = j;
  
          /* And continue down the tree, setting j to the left son of k */
          j <<= 1;
***************
*** 838,844 ****
      Assert (lcodes <= L_CODES && dcodes <= D_CODES && blcodes <= BL_CODES,
              "too many codes");
      Tracev((stderr, "\nbl counts: "));
!     send_bits(lcodes-257, 5); /* not +255 as stated in appnote.txt */
      send_bits(dcodes-1,   5);
      send_bits(blcodes-4,  4); /* not -3 as stated in appnote.txt */
      for (rank = 0; rank < blcodes; rank++) {
--- 841,848 ----
      Assert (lcodes <= L_CODES && dcodes <= D_CODES && blcodes <= BL_CODES,
              "too many codes");
      Tracev((stderr, "\nbl counts: "));
!     send_bits(lcodes-257, 5);
!     /* not +255 as stated in appnote.txt 1.93a or -256 in 2.04c */
      send_bits(dcodes-1,   5);
      send_bits(blcodes-4,  4); /* not -3 as stated in appnote.txt */
      for (rank = 0; rank < blcodes; rank++) {
***************
*** 898,903 ****
--- 902,908 ----
  
      if (static_lenb <= opt_lenb) opt_lenb = static_lenb;
  
+ #ifndef PGP /* PGP can't handle stored blocks */
      /* If compression failed and this is the first and last block,
       * and if the zip file can be seeked (to rewrite the local header),
       * the whole file is transformed into a stored file:
***************
*** 913,923 ****
          copy_block(buf, (unsigned)stored_len, 0); /* without header */
          compressed_len = stored_len << 3;
          *file_method = STORE;
  
  #ifdef FORCE_METHOD
!     } else if (level == 2 && buf != NULL) { /* force stored block */
  #else
!     } else if (stored_len+4 <= opt_lenb && buf != NULL) {
                         /* 4: two words for the lengths */
  #endif
          /* The test buf != NULL is only necessary if LIT_BUFSIZE > WSIZE.
--- 918,930 ----
          copy_block(buf, (unsigned)stored_len, 0); /* without header */
          compressed_len = stored_len << 3;
          *file_method = STORE;
+     } else
+ #endif /* PGP */
  
  #ifdef FORCE_METHOD
!     if (level == 2 && buf != (char*)NULL) { /* force stored block */
  #else
!     if (stored_len+4 <= opt_lenb && buf != (char*)NULL) {
                         /* 4: two words for the lengths */
  #endif
          /* The test buf != NULL is only necessary if LIT_BUFSIZE > WSIZE.
***************
*** 950,956 ****
--- 957,973 ----
      init_block();
  
      if (eof) {
+ #if defined(PGP) && !defined(MMAP)
+         /* Wipe out sensitive data for pgp */
+ # ifdef DYN_ALLOC
+         extern uch *window;
+ # else
+         extern uch window[];
+ # endif
+         memset(window, 0, (unsigned)(2*WSIZE-1)); /* -1 needed if WSIZE=32K */
+ #else /* !PGP */
          Assert (input_len == isize, "bad input size");
+ #endif
          bi_windup();
          compressed_len += 7;  /* align on byte boundary */
      }
***************
*** 1078,1084 ****
--- 1095,1103 ----
      while (n < 128)    ascii_freq += dyn_ltree[n++].Freq;
      while (n < LITERALS) bin_freq += dyn_ltree[n++].Freq;
      *file_type = bin_freq > (ascii_freq >> 2) ? BINARY : ASCII;
+ #ifndef PGP
      if (*file_type == BINARY && translate_eol) {
          warn("-l used on binary file", "");
      }
+ #endif
  }
diff -c ../zip19i/util.c ./util.c
*** ../zip19i/util.c	Tue Nov  3 21:07:56 1992
--- ./util.c	Mon Sep  6 22:31:08 1993
***************
*** 1,11 ****
  /*
  
!  Copyright (C) 1990-1992 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included
!  unmodified, that it is not sold for profit, and that this copyright notice
!  is retained.
  
  */
  
--- 1,10 ----
  /*
  
!  Copyright (C) 1990-1993 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included,
!  that it is not sold for profit, and that this copyright notice is retained.
  
  */
  
***************
*** 27,33 ****
  #ifndef UTIL /* UTIL picks out namecmp code (all utils) */
  
  /* Local functions */
! local int recmatch OF((char *, char *));
  
  #if (defined(MSDOS) && !defined(OS2) && !defined(__GO32__) && !defined(WIN32))
    local unsigned ident OF((unsigned chr));
--- 26,32 ----
  #ifndef UTIL /* UTIL picks out namecmp code (all utils) */
  
  /* Local functions */
! local int recmatch OF((uch *, uch *));
  
  #if (defined(MSDOS) && !defined(OS2) && !defined(__GO32__) && !defined(WIN32))
    local unsigned ident OF((unsigned chr));
***************
*** 52,65 ****
  
  
  local int recmatch(p, s)
! char *p;                /* sh pattern to match */
! char *s;                /* string to match it to */
  /* Recursively compare the sh pattern p with the string s and return 1 if
     they match, and 0 or 2 if they don't or if there is a syntax error in the
     pattern.  This routine recurses on itself no deeper than the number of
     characters in the pattern. */
  {
!   int c;                /* pattern char or start of range in [-] loop */ 
  
    /* Get first character, the pattern for new recmatch calls follows */
    c = *p++;
--- 51,64 ----
  
  
  local int recmatch(p, s)
! uch *p;       /* sh pattern to match */
! uch *s;       /* string to match it to */
  /* Recursively compare the sh pattern p with the string s and return 1 if
     they match, and 0 or 2 if they don't or if there is a syntax error in the
     pattern.  This routine recurses on itself no deeper than the number of
     characters in the pattern. */
  {
!   unsigned int c;       /* pattern char or start of range in [-] loop */ 
  
    /* Get first character, the pattern for new recmatch calls follows */
    c = *p++;
***************
*** 77,82 ****
--- 76,85 ----
      return *s ? recmatch(p, s + 1) : 0;
  
    /* '*' matches any number of characters, including zero */
+ #ifdef AMIGA
+   if (c == '#' && *p == '?')            /* "#?" is Amiga-ese for "*" */
+     c = '*', p++;
+ #endif /* AMIGA */
    if (c == '*')
    {
      if (*p == 0)
***************
*** 92,103 ****
    if (c == '[')
    {
      int e;              /* flag true if next char to be taken literally */
!     char *q;            /* pointer to end of [-] group */
      int r;              /* flag true to match anything but the range */
  
      if (*s == 0)                        /* need a character to match */
        return 0;
!     p += (r = *p == '!');               /* see if reverse */
      for (q = p, e = 0; *q; q++)         /* find closing bracket */
        if (e)
          e = 0;
--- 95,106 ----
    if (c == '[')
    {
      int e;              /* flag true if next char to be taken literally */
!     uch *q;   /* pointer to end of [-] group */
      int r;              /* flag true to match anything but the range */
  
      if (*s == 0)                        /* need a character to match */
        return 0;
!     p += (r = (*p == '!' || *p == '^')); /* see if reverse */
      for (q = p, e = 0; *q; q++)         /* find closing bracket */
        if (e)
          e = 0;
***************
*** 116,124 ****
          c = *(p-1);
        else
        {
          if (*(p+1) != '-')
            for (c = c ? c : *p; c <= *p; c++)    /* compare range */
!             if (case_map(c) == case_map(*s))
                return r ? 0 : recmatch(q + 1, s + 1);
          c = e = 0;                      /* clear range, escape flags */
        }
--- 119,128 ----
          c = *(p-1);
        else
        {
+         unsigned int cc = case_map(*s);
          if (*(p+1) != '-')
            for (c = c ? c : *p; c <= *p; c++)    /* compare range */
!             if (case_map(c) == cc)
                return r ? 0 : recmatch(q + 1, s + 1);
          c = e = 0;                      /* clear range, escape flags */
        }
***************
*** 143,153 ****
  /* Compare the sh pattern p with the string s and return true if they match,
     false if they don't or if there is a syntax error in the pattern. */
  {
!   return recmatch(p, s) == 1;
  }
  
  
! #ifdef MSDOS
  
  int dosmatch(p, s)
  char *p;                /* dos pattern to match */
--- 147,157 ----
  /* Compare the sh pattern p with the string s and return true if they match,
     false if they don't or if there is a syntax error in the pattern. */
  {
!   return recmatch((uch *) p, (uch *) s) == 1;
  }
  
  
! #if defined(MSDOS) && !defined(WIN32)
  
  int dosmatch(p, s)
  char *p;                /* dos pattern to match */
***************
*** 187,193 ****
  voidp *b;               /* pointer to value to search for */
  voidp far **a;          /* table of pointers to values, sorted */
  extent n;               /* number of pointers in a[] */
! int (*cmp) OF((voidp *, voidp far *));  /* comparison function for search */
  /* Search for b in the pointer list a[0..n-1] using the compare function
     cmp(b, c) where c is an element of a[i] and cmp() returns negative if
     *b < *c, zero if *b == *c, or positive if *b > *c.  If *b is found,
--- 191,198 ----
  voidp *b;               /* pointer to value to search for */
  voidp far **a;          /* table of pointers to values, sorted */
  extent n;               /* number of pointers in a[] */
! int (*cmp) OF((const voidp *, const voidp far *)); /* comparison function */
! 
  /* Search for b in the pointer list a[0..n-1] using the compare function
     cmp(b, c) where c is an element of a[i] and cmp() returns negative if
     *b < *c, zero if *b == *c, or positive if *b > *c.  If *b is found,
***************
*** 368,375 ****
  
    for (;;)
    {
!     d = (int) (unsigned char) case_map(*string1)
!       - (int) (unsigned char) case_map(*string2);
      
      if (d || *string1 == 0 || *string2 == 0)
        return d;
--- 373,380 ----
  
    for (;;)
    {
!     d = (int) (uch) case_map(*string1)
!       - (int) (uch) case_map(*string2);
      
      if (d || *string1 == 0 || *string2 == 0)
        return d;
Only in .: vms
